//@ sourceURL=user_manage.js
$(function () {
    $("input").each(function (){
        this.onkeydown = function (e) { // 监听键盘事件
            let theEvent = window.event || e;
            let code = theEvent.keyCode || theEvent.which;
            if (code == 13) {//回车事件
                $("#btn_search").click(); //触发搜索按钮点击事件
            }
        }
    });
    //新增按钮点击事件
    $("#btn_add").click(function (t) {
        $("#editModal").modal();
        $("#classTitle").text("新增");
        $("#groupNo").removeAttr("disabled");
        clearInput();
    });
    //角色保存按钮点击事件
    $("#btn_save").click(function (t) {
        var validatorResult = validator.checkAll($("#editDrugWinForm"));
        if (validatorResult) {
            saveDrugWin();
        }
    });
    //初始化表格数据
    getAllDrugWin();
    getAllGroupName();
});


//初始化药房下拉
function getAllGroupName() {
    $.ajax({
        type: "GET",
        url: '/thmz/queryAllGroupName',
        contentType: "application/json;charset=UTF-8",
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view';
                return;
            }
            if (res.code == 0) {
                //初始化部门下拉
                var arr = res.data;
                if (arr != null && arr.length > 0) {
                    var html = "";
                    for (var i = 0; i < arr.length; i++) {
                        html += "<option value='" + arr[i].groupNo + "'>" + arr[i].groupName + "</option>";
                    }
                    $('#groupNo').html(html);
                    $('#groupNo').selectpicker('refresh');
                } else {
                    errorMesage(res);
                }
            }
        }
    });
}


/**
 * 保存发药窗口数据
 */
function saveDrugWin() {
    var data = JSON.stringify({
        winNo: $("#winNo").val(),
        groupNo: $("#groupNo").val(),
        winName: $("#winName").val(),
        winCate: $("#winCate").val(),
        isEdit: $("#winNo").attr("readonly") == 'readonly' ? 1 : 0 //1：修改 0：新增
    });
    $.ajax({
        type: "POST",
        url: '/thmz/saveDrugWin',
        contentType: "application/json;charset=UTF-8",
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        data: data,
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if (res.code == 0) {
                $("#editModal").modal("hide");
                clearInput();
                $('#tb_table').bootstrapTable('refresh');
                successMesage(res);
            } else {
                errorMesage(res);
            }
        }
    });
}


/**
 * 清空输入框
 */
function clearInput() {
    $("#winNo").attr("readonly", false);
    $("#winNo").val(null);
    $("#groupNo").val(null);
    $("#winName").val(null);
    $("#winCate").val(0);
    $("#groupNo").selectpicker('refresh');
    $("#winCate").selectpicker('refresh');
}

/**
 * 重置查询表单
 */
function resetSearch() {
    $("#winNoSearch").val(null);
    $("#groupNoSearch").val(null);
    $("#winNameSearch").val(null);
}


/**
 * 查询发药窗口列表
 */
function getAllDrugWin() {
    $('#tb_table').bootstrapTable("destroy");
    $('#tb_table').bootstrapTable({
        url: '/thmz/listDrugWin',         //请求后台的URL（*）
        method: 'post',                      //请求方式（*）
        toolbar: '#toolbar',                //工具按钮用哪个容器
        striped: true,                      //是否显示行间隔色
        cache: false,                       //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
        pagination: true,                   //是否显示分页（*）
        sortable: true,                     //是否启用排序
        sortOrder: "desc",                   //排序方式
        queryParams: queryParams,           //传递参数（*）
        sidePagination: "server",           //分页方式：client客户端分页，server服务端分页（*）
        pageNumber: 1,                       //初始化加载第一页，默认第一页
        pageSize: 10,                       //每页的记录行数（*）
        pageList: [10, 15, 25, 50, 100],        //可供选择的每页的行数（*）
        search: false,                       //是否显示表格搜索，此搜索是客户端搜索，不会进服务端，所以，个人感觉意义不大
        strictSearch: true,
        showColumns: false,                  //是否显示所有的列
        showRefresh: false,                  //是否显示刷新按钮
        minimumCountColumns: 2,             //最少允许的列数
        clickToSelect: true,                //是否启用点击选中行
        uniqueId: "winNo",                     //每一行的唯一标识，一般为主键列
        showToggle: false,                    //是否显示详细视图和列表视图的切换按钮
        cardView: false,                    //是否显示详细视图
        detailView: false,
        //rowStyle:rowStyle,//通过自定义函数设置行样式
        ajaxOptions: {
            headers: {
                'Accept': 'application/json',
                'Authorization': 'Bearer ' + localStorage.getItem("token")
            }
        },
        columns: [
            {
                title: '操作',
                field: 'op',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    var groupNo = row.groupNo;
                    var winNo = row.winNo;
                    row.winName = row.winName.trim();
                    row = JSON.stringify(row);
                    var str = '<button type="button" class="btn btn-primary  btn-sm" onclick=updateDrugWin(' + row + ')>编辑</button>';
                    /*str += '<button type="button" class="btn btn-warning  btn-sm" onclick=removeByGroupNoWinNo(' + groupNo+','+ winNo + ')>删除</button>';*/
                    return [str].join('');
                }
            },
            {
                field: 'groupName',
                title: '药房名称',
                align: "center",
                valign: 'middle'
            },
            {
                field: 'winNo',
                title: '窗口编号',
                align: "center",
                valign: 'middle'
            },
            {
                field: 'winName',
                title: '窗口名称',
                align: "center",
                valign: 'middle'
            }, {
                field: 'winCate',
                title: '状态',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    return value == 1 ? '<span style="color: green">开放</span>' : '<span style="color: red">未开放</span>';
                }
            }
        ],
        responseHandler: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            var ress = eval(res);
            if (ress.code == -1) {
                if (ress.message != null && ress.message != '') {
                    new PNotify({
                        title: '错误提示',
                        text: ress.message,
                        type: 'error',
                        hide: true,
                        styling: 'bootstrap3'
                    });
                }
                return {
                    "total": 0,//总页数
                    "rows": {}   //数据
                };
            }
            return {
                "total": ress.total,//总页数
                "rows": ress.data   //数据
            };
        },
    });
}


/**
 * 构建列表查询参数
 * @param params
 * @returns {{mzChargeDetail: {patientId: string | number | string[] | undefined | jQuery, warnDept: string | number | string[] | undefined | jQuery, doctorCode: string | number | string[] | undefined | jQuery, name: string | number | string[] | undefined | jQuery, payMark: number}, beginTime: Date, endTime: Date, pageSize: *, pageIndex: number}}
 */
function queryParams(params) {
    var temp = {   //这里的键的名字和控制器的变量名必须一直，这边改动，控制器也需要改成一样的
        pageSize: params.limit,   //页面大小
        pageIndex: params.offset / params.limit,  //页码
        mzDrugWin: {
            winNo: $("#winNoSearch").val() == "" ? null : $("#winNoSearch").val(),
            groupNo: $("#groupNoSearch").val() == "" ? null : $("#groupNoSearch").val(),
            winName: $("#winNameSearch").val() == "" ? null : $("#winNameSearch").val()
        }
    };
    return temp;
}


/**
 * 打开编辑窗口
 * @param row
 */
function updateDrugWin(row) {
    clearInput();
    $("#winNo").attr("readonly", true);
    $("#classTitle").text("修改");
    $("#winNo").val(row.winNo);
    $("#groupNo").val(row.groupNo);
    $("#groupNo").attr("disabled","disabled");
    $("#winName").val(row.winName);
    $("#winCate").val(row.winCate);
    $("#winCate").selectpicker('refresh');
    $("#groupNo").selectpicker('refresh');
    $("#editModal").modal();
}

/**
 * 删除发药窗口
 * @param id
 */
function removeByGroupNoWinNo(groupNo,winNo) {
    if (!confirm("是否要删除当前发药窗口？")) {
        return;
    }
    $.ajax({
        type: "GET",
        url: '/thmz/removeByGroupNoWinNo?groupNo=' + groupNo+'&winNo='+winNo,
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if (res.code == 0) {
                $('#tb_table').bootstrapTable('refresh');
                successMesage(res);
            } else {
                errorMesage(res);
            }
        }
    });
}
